/***************************************************************************
 *            dia-textus-imago.c
 *
 *  Thu Sep 28 11:59:36 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#include "dia-textus-imago.h"
#include "dia-canvas-image.h"

#include "dia-shape.h"
#include <libart_lgpl/art_affine.h>
#include "dia-canvas-i18n.h"
#include "dia-canvas-groupable.h"
#include "dia-canvas-text.h"
int tama[2];  /*El arreglo de dos, para el tamaño*/
/*LAS PROPIEDADES DEL textusImago DE TEXTO*/
/*

*/
enum {
	PROP_TYPUS=1,
	PROP_TEXTUS,
	PROP_NOMENIS,	/*EL NOMBRE OFICIAL DE LA CAJA DE TEXTO QUE IDENTIFICA AL textusImago*/
	PROP_IMAGO,		/*sí es una imagen, se le pasa como parámetro la dirección*/
	PROP_TAMAGNUS_TYPUS	/*EL TAMAÑO DE LA FUENTE*/ /*HAY QUE PONERLO DE PRIMERO */
//	PROP_COLOR,		/*COLOR DEL PERÍMETRO*/
//	PROP_PERIMETROS_AMPLUS   /*ancho de la línea del perímetro*/

};

static void dia_textus_imago_init		(DiaTextusImago* textusImago);
static void dia_textus_imago_class_init	(DiaTextusImagoClass *klass);
static void dia_textus_imago_groupable_init	(DiaCanvasGroupableIface *groupable);
static void dia_textus_imago_dispose		(GObject *object);
static void dia_textus_imago_update		(DiaCanvasItem *item,gdouble affine[6]);
/*Establece laas propiedades del elemento*/
static void propiedades_textus_imago(GObject* objeto,guint id_propiedad, const GValue* propiedad, GParamSpec* especificacion);
/*entrega las propiedades del textusImago*/
static void entrega_propiedades_textus_imago(GObject* objeto,guint id_propiedad,GValue* parametros,GParamSpec* especificacion);



/*Para las formas*/
//static gboolean dia_textus_imago_get_shape_iter (DiaCanvasItem *item, DiaCanvasIter *iter);

//static gboolean dia_textus_imago_shape_next (DiaCanvasItem *item, DiaCanvasIter *iter);

//static DiaShape* dia_textus_imago_shape_value	(DiaCanvasItem *item,DiaCanvasIter *iter);





/*La función encargada de obtener el tamaño del elemento*/
int* tama_elemento_textus_imago(DiaCanvasElement* textusImago);
	
	

//static gboolean dia_textbox_event	(DiaCanvasItem *item,
//					 DiaEvent *event);

/* Interface functions: */
static void dia_textus_imago_groupable_add	(DiaCanvasGroupable *textusImago,DiaCanvasItem *item);
static void dia_textus_imago_groupable_remove	(DiaCanvasGroupable *textusImago,DiaCanvasItem *item);
static gboolean dia_textus_imago_groupable_get_iter	(DiaCanvasGroupable *textusImago,DiaCanvasIter *iter);
static gboolean dia_textus_imago_groupable_next	(DiaCanvasGroupable *textusImago,DiaCanvasIter *iter);
static DiaCanvasItem* dia_textus_imago_groupable_value (DiaCanvasGroupable *textusImago, DiaCanvasIter *iter);
static gint dia_textus_imago_groupable_length	(DiaCanvasGroupable *textusImago);
static gint dia_textus_imago_groupable_pos	(DiaCanvasGroupable *textusImago,DiaCanvasItem *item);
static gboolean dia_textus_sequens_forma(DiaCanvasItem* item,DiaCanvasIter *iter);
static DiaCanvasElementClass *parent_class = NULL;

/*ES PARA HACER EL OBJETO TAL CUAL gboject y heredar de diacanvas*/
GType dia_textus_imago_get_type (void)
{
	static GType object_type = 0;

	if (!object_type) {
		static const GTypeInfo object_info = {
			sizeof (DiaTextusImagoClass),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) dia_textus_imago_class_init,
			(GClassFinalizeFunc) NULL,
			(gconstpointer) NULL, /* class_data */
			sizeof (DiaTextusImago),
			(guint16) 0, /* n_preallocs */
			(GInstanceInitFunc) dia_textus_imago_init,
		};
		static const GInterfaceInfo groupable_info = {
			(GInterfaceInitFunc) dia_textus_imago_groupable_init,
			NULL,
			NULL,
		};
		object_type = g_type_register_static (DIA_TYPE_CANVAS_VARIUS_FORMA,
						      "DiaTextusImago",
						      &object_info, 0);
		g_type_add_interface_static (object_type,
					     DIA_TYPE_CANVAS_GROUPABLE,
					     &groupable_info);
	}

	return object_type;
}
/*El que inica la clase*/
static void dia_textus_imago_class_init (DiaTextusImagoClass *klass)
{
	GObjectClass *object_class;
	DiaCanvasItemClass *item_class;
 
	object_class = (GObjectClass*) klass;
	item_class = DIA_CANVAS_ITEM_CLASS(klass);

	parent_class = g_type_class_peek_parent (klass);

	object_class->dispose = dia_textus_imago_dispose;
        /*Función que ingresa las propiedades*/ 
        object_class->set_property=propiedades_textus_imago; 
	/*función que entrega los parámetros*/
	object_class->get_property=entrega_propiedades_textus_imago;  
	
	item_class->update = dia_textus_imago_update;

	/*para las formas*/
//       item_class->get_shape_iter = dia_textus_imago_get_shape_iter;
//       item_class->shape_next = dia_textus_imago_shape_next;
//       item_class->shape_value = dia_textus_imago_shape_value;

       
	//item_class->event = dia_textbox_event;

	//item_class->point = dia_textbox_point;
	/*g_object_class_install_property (object_class,
					 PROP_FONT,
					 g_param_spec_boxed ("font",
						_("Font description"),
						_(""),
						PANGO_TYPE_FONT_DESCRIPTION,
						G_PARAM_WRITABLE));
	g_object_class_install_property (object_class,
					 PROP_TEXT,
					 g_param_spec_string ("text",
						_("Text"),
						_("Text to be displayed"),
						NULL,
						G_PARAM_READWRITE));
	*/					
	/* se ponen más propiedades */	
	/*LA PROPIEDAD DEL TAMAÑO DE LA FUENTE*/
	g_object_class_install_property(object_class,PROP_TAMAGNUS_TYPUS,g_param_spec_int("tamagnus_typus","Tamaño","Tamaño de la fuente",G_MININT,G_MAXINT,0,G_PARAM_READWRITE));

	g_object_class_install_property(object_class,PROP_TAMAGNUS_TYPUS,g_param_spec_int("size",_("font size"),_("font size"),G_MININT,G_MAXINT,0,G_PARAM_READWRITE));

	/*La propiedad de nombre de función del elemento*/
	g_object_class_install_property(object_class,PROP_NOMENIS,g_param_spec_string("nomenis","Texto","Nombre de la función del elemento",NULL,G_PARAM_READWRITE));

	g_object_class_install_property(object_class,PROP_NOMENIS,g_param_spec_string("name","Text","function name",NULL,G_PARAM_READWRITE));
	

	/*La propiedad de nombre de función del elemento*/
	g_object_class_install_property(object_class,PROP_TEXTUS,g_param_spec_string("textus","Texto","texto del usuario",NULL,G_PARAM_READWRITE));
	
	g_object_class_install_property(object_class,PROP_NOMENIS,g_param_spec_string("text","Text","user's text",NULL,G_PARAM_READWRITE));

	/*La propiedad de La IMAGEN A SER PUESTA como componente central*/
	g_object_class_install_property(object_class,PROP_IMAGO,g_param_spec_pointer("imagos","Imagen","Representación del elemento",G_PARAM_READWRITE));
	
	g_object_class_install_property(object_class,PROP_IMAGO,g_param_spec_pointer("image","Image","Image",G_PARAM_READWRITE));


  /*  g_object_class_install_property (object_class,
					 PROP_COLOR,
					 g_param_spec_ulong ("color",
						_("Color"),
						_("Color of the line in RGBA"),
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));
	
       g_object_class_install_property (object_class,
					 PROP_COLOR,
					 g_param_spec_ulong ("color",
						_("Color"),
						"El color de la línea en formato RGBA",
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));
 */
/*      g_object_class_install_property (object_class,
					 PROP_PERIMETROS_AMPLUS,
					 g_param_spec_double ("border_width",
						_("Border width"),
						_("width of the border"),
						-G_MAXDOUBLE, G_MAXDOUBLE, 1.0,
						G_PARAM_READWRITE));
	
     g_object_class_install_property (object_class,
					 PROP_PERIMETROS_AMPLUS,
					 g_param_spec_double ("perimetros_amplus",
						"Ancho de la marca del perímetro",
						_("perimetros amplus"),
						-G_MAXDOUBLE, G_MAXDOUBLE, 1.0,
						G_PARAM_READWRITE));

 */
    g_object_class_install_property (object_class,
					 PROP_TYPUS,
					 g_param_spec_boxed ("typus",
						"Tipografía para las letras ",
						"tipografía",
						PANGO_TYPE_FONT_DESCRIPTION,
						G_PARAM_WRITABLE));

	g_object_class_install_property (object_class,
					 PROP_TYPUS,
					 g_param_spec_boxed ("font",
						_("Font description"),
						_(""),
						PANGO_TYPE_FONT_DESCRIPTION,
						G_PARAM_WRITABLE));
		
}
/* El que incia la interfaz de agrupación*/
static void dia_textus_imago_groupable_init (DiaCanvasGroupableIface *groupable)
{
	groupable->add = dia_textus_imago_groupable_add;
	groupable->remove = dia_textus_imago_groupable_remove;
	groupable->get_iter = dia_textus_imago_groupable_get_iter;
	groupable->next = dia_textus_imago_groupable_next;
	groupable->value = dia_textus_imago_groupable_value;
	groupable->length = dia_textus_imago_groupable_length;
	groupable->pos = dia_textus_imago_groupable_pos;
}

/*Inicia el objeto diatextbox
* LA PARECER NO PERMITE LA CRTEACIÓN DINÁMICA DEL OBJETO
* EN TÉRMINOS DE NUEVO, HAY QUE INICIALIZAR
* EL ITEM Y LUEGO SE PUEDE PARAMETRIZAR
* el mismo de textusImagos.
*
*/
static void dia_textus_imago_init (DiaTextusImago* textusImago)
{ 
	int* tama; /*El tamaño del  ancho objeto es la pos 0, alto la pos 1*/
	int ancho, alto;
	/*Fuente*/
	tama=tama_elemento_textus_imago((DiaCanvasElement*)textusImago);
	textusImago->typus=pango_font_description_new(); /*La fuente del elemento*/
        pango_font_description_set_size(textusImago->typus,8000*PANGO_SCALE_LARGE);
	/*TEXTO SUPERIOR*/
	/*Es el texto superior de la imagen, el que indica el tipo de elemento que es*/
	textusImago->textus = dia_canvas_item_create (DIA_TYPE_CANVAS_TEXT, NULL);

	dia_canvas_item_set_child_of (textusImago->textus, DIA_CANVAS_ITEM (textusImago)); 
        dia_canvas_item_set_parent(textusImago->textus,DIA_CANVAS_ITEM(textusImago));
	/*EL TEXTO INFERIOR*/
	/*Es el texto inferior de la imagen */
	textusImago->textus_bassus=dia_canvas_item_create (dia_canvas_text_get_type(),
                                                           "editable", FALSE,"markup", TRUE,NULL);

      
        /*hijo de este componente*/
	dia_canvas_item_set_child_of(textusImago->textus_bassus,DIA_CANVAS_ITEM(textusImago));  
        dia_canvas_item_set_parent(textusImago->textus_bassus,DIA_CANVAS_ITEM(textusImago));
       /*Pone el componente en la parte central del cuadrado, según las dimensiones*/
	dia_canvas_item_move(textusImago->textus_bassus,0,tama[1]*0.85);
	/*EL textusImago TIPO IMAGEN*/
	textusImago->centrum=dia_canvas_item_create(dia_canvas_image_get_type(),NULL);
 	dia_canvas_item_set_child_of(textusImago->centrum,DIA_CANVAS_ITEM(textusImago));  
        dia_canvas_item_set_parent(textusImago->centrum,DIA_CANVAS_ITEM(textusImago));
	tama=tama_elemento_textus_imago((DiaCanvasElement*)textusImago);
  /*ídem*/
        DIA_CANVAS_ELEMENT (textusImago->centrum)->width = tama[0]*0.8;
        DIA_CANVAS_ELEMENT (textusImago->centrum)->height = tama[1]*0.8;

	dia_canvas_item_move(textusImago->centrum,tama[0]*(1-0.8),tama[1]*(1-0.8));
  	
  }
  
/*La función para el tamaño del elemento*/
 int* tama_elemento_textus_imago(DiaCanvasElement* textusImago)
	{
		/*El primer valor es el ancho, el segundo es el alto*/
		tama[0]=(int)DIA_CANVAS_ELEMENT (textusImago)->width;	
		tama[1]=(int)DIA_CANVAS_ELEMENT (textusImago)->height;
		return tama;
	}
 
  
/*Entrega la memoria ocupada de los elementos al sistema*/
static void dia_textus_imago_dispose (GObject *object)
{
	DiaTextusImago *textusImago = (DiaTextusImago*) object;

	if (textusImago->textus) {   /*libera el primer texto, el que describe el elemento*/
		g_object_unref (textusImago->textus);
		textusImago->textus = NULL;
	}
	if(textusImago->textus_bassus){
		g_object_unref (textusImago->textus_bassus); /*texto de usuario*/
		textusImago->textus_bassus=NULL;
	}if(textusImago->centrum)
	  {
		g_object_unref (textusImago->centrum); /*componente central*/
		textusImago->centrum = NULL;
	  }	  
	G_OBJECT_CLASS (parent_class)->dispose (object);
}
/*Actualiza la cja de texto*/
static void dia_textus_imago_update (DiaCanvasItem *item, gdouble affine[6])
{
	DiaTextusImago *textusImago;
	DiaPoint punctus; 
        punctus.x=0.0;  /* --- Punto incial	---*/
	punctus.y=0.0;
	int *tama;
	g_return_if_fail(item != NULL);
	g_return_if_fail(DIA_IS_TEXTUS_IMAGO(item));
	
	DIA_CANVAS_ITEM_CLASS (parent_class)->update (item, affine);
	textusImago = DIA_TEXTUS_IMAGO(item);
        if( dia_canvas_item_is_selected(DIA_CANVAS_ITEM(textusImago->centrum)) ||dia_canvas_item_is_focused(DIA_CANVAS_ITEM(textusImago->centrum)) )
	  { 
	    dia_canvas_item_unselect(DIA_CANVAS_ITEM(textusImago->centrum));  
	    dia_canvas_item_select(DIA_CANVAS_ITEM(textusImago));
	    dia_canvas_item_focus(DIA_CANVAS_ITEM(textusImago));
	  }	

        /*Recupera el tamaño del objeto :) */
	tama=tama_elemento_textus_cuadrus((DiaCanvasElement*)textusImago);
        /*El ancho del elemento de texto es el de el todo :)*/
	DIA_CANVAS_TEXT (textusImago->textus)->width =tama[0];
        /*el largo, es el de la mitad :)*/
	DIA_CANVAS_TEXT (textusImago->textus)->height =tama[1]/2;

        /*ídem*/     
	DIA_CANVAS_TEXT (textusImago->textus_bassus)->width = tama[0];
	DIA_CANVAS_TEXT (textusImago->textus_bassus)->height = tama[1]/2;
        /*ídem*/
        DIA_CANVAS_ELEMENT (textusImago->centrum)->width = tama[0]*0.8;
        DIA_CANVAS_ELEMENT (textusImago->centrum)->height = tama[1]*0.8;


        /*  Pone el elemento en arriba de acuerdo a su tamaño*/
         DIA_CANVAS_ITEM(textusImago->textus)->affine[4]=0;
         DIA_CANVAS_ITEM(textusImago->textus)->affine[5]=0;

        /*  Pone el elemento abajo de acuerdo a su tamaño*/
         DIA_CANVAS_ITEM(textusImago->textus_bassus)->affine[4]=0;
         DIA_CANVAS_ITEM(textusImago->textus_bassus)->affine[5]=tama[1]*(1-0.5);

        
        /*  Pone el elemento en el centro, de acuerdo a su tamaño*/
         DIA_CANVAS_ITEM(textusImago->centrum)->affine[4]=tama[0]*(1-0.9);
         DIA_CANVAS_ITEM(textusImago->centrum)->affine[5]=tama[1]*(1-0.9);


         if (DIA_CANVAS_ITEM_GET_CLASS (textusImago->textus)->update) 
              {
		gdouble a[6];
		art_affine_multiply (a, affine, textusImago->textus->affine);
		//g_message ("%f %f %f %f %f %f",
		//	   a[0], a[1], a[2],  a[3], a[4], a[5]);
		DIA_CANVAS_ITEM_GET_CLASS (textusImago->textus)->update (textusImago->textus, a);
	       }else
		g_assert_not_reached ();
	    DIA_UNSET_FLAGS (textusImago->textus, DIA_NEED_UPDATE);
	
	if (DIA_CANVAS_ITEM_GET_CLASS (textusImago->textus_bassus)->update) 
	{
	 gdouble a[6];
	 art_affine_multiply (a, affine, textusImago->textus_bassus->affine);
	 //g_message ("%f %f %f %f %f %f",
	//	   a[0], a[1], a[2],  a[3], a[4], a[5]);
	DIA_CANVAS_ITEM_GET_CLASS (textusImago->textus_bassus)->update (textusImago->textus_bassus,
                                  a);
        }else
	g_assert_not_reached ();
   	    DIA_UNSET_FLAGS (textusImago->textus_bassus, DIA_NEED_UPDATE);
   
   if (DIA_CANVAS_ITEM_GET_CLASS (textusImago->centrum)->update) 
	     {
		gdouble a[6];
		DIA_CANVAS_ITEM_GET_CLASS(textusImago->centrum)->update (textusImago->centrum, a);
              }else
		g_assert_not_reached ();
   	    DIA_UNSET_FLAGS (textusImago->centrum, DIA_NEED_UPDATE);
}
 
#if 0   /*eventos para la caja de texto*/
static gboolean dia_textus_imago_event (DiaCanvasItem *item, DiaEvent *event)
{
	/* Request updates for the text at some events. */
	switch (event->type) {
	case DIA_EVENT_BUTTON_PRESS:
		if (event->button.button == 1) {
			dia_canvas_item_request_update (DIA_TEXTUS_IMAGO (item)->texto);
			dia_canvas_item_request_update (DIA_TEXTUS_IMAGO (item)->textus);
			dia_canvas_item_request_update (DIA_TEXTUS_IMAGO (item)->centro);
			printf("evento 1\n");
			dia_canvas_item_unfocus(DIA_TEXTUS_IMAGO (item)->centro);
		}
		break;
	case DIA_EVENT_BUTTON_RELEASE:
		if (DIA_CANVAS_ITEM_GRAB (item)) {
			dia_canvas_item_request_update (DIA_TEXTUS_IMAGO (item)->texto);
			dia_canvas_item_request_update (DIA_TEXTUS_IMAGO (item)->textus);
			/*dia_canvas_item_request_update (DIA_TEXTUS_IMAGO (item)->centro);*/
			dia_canvas_item_ungrab(DIA_TEXTUS_IMAGO (item)->centro);
			printf("evento 2\n");
		}
		break;
	case DIA_EVENT_MOTION:
		if (DIA_CANVAS_ITEM_GRAB (item)) {
			dia_canvas_item_request_update (DIA_TEXTUS_IMAGO (item)->texto);
			dia_canvas_item_request_update (DIA_TEXTUS_IMAGO (item)->textus);
			/*dia_canvas_item_request_update (DIA_TEXTUS_IMAGO (item)->centro);*/
			dia_canvas_item_ungrab(DIA_TEXTUS_IMAGO (item)->centro);
			printf("evento 3\n");
		}
	default:
		break;
	}
	return DIA_CANVAS_ITEM_CLASS (parent_class)->event (item, event);
}
#endif

/*Establece laas propiedades del elemento
 *Se le pasa como parámetros:
 * El objeto.
 *  El identificador de la propiedad,
 *   La propiedad
 *   La especificación de la propiedad
 * las posible propiedades son:

*/
static void propiedades_textus_imago(GObject* objeto,guint id_propiedad, const GValue* propiedad, GParamSpec* especificacion)
{   
	DiaTextusImago* textusImago; 

	int valor;
        long valor_l;
        double valor_d;
        char* tex_tus;
	textusImago=(DiaTextusImago*)objeto;		/*Cambio de tipo*/
				  
	switch(id_propiedad)
	{	
	    case PROP_TYPUS:  /*La tipografía de la letra*/
		 {
		  /*La tipografía del elemento*/	
                  textusImago->typus=g_value_get_boxed(propiedad); 
                  g_object_set(DIA_TEXTUS_IMAGO(objeto)->textus_bassus,"font",
                                      textusImago->typus,NULL);
                  g_object_set(textusImago->textus,"font",textusImago->typus,NULL);
                  dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));	
		 }break;	
            case PROP_TAMAGNUS_TYPUS:  /*tamaño de la fuente, ha de ser la primera*/
		{
		 valor=g_value_get_int(propiedad);	
		 pango_font_description_set_size(textusImago->typus,valor*PANGO_SCALE_LARGE);
                 dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));
		}break;	
	    case PROP_NOMENIS:  /*el nombre del cuadro*/
		 {
                   DIA_TEXTUS_IMAGO(objeto)->nomenis=(char*)g_value_get_string(propiedad);
		    /*Al cuadro de texto se le pone el valor dado*/  
		   g_object_set(DIA_TEXTUS_IMAGO(objeto)->textus_bassus,"font",
                                      textusImago->typus,"text",textusImago->nomenis,
                                      "editable",FALSE,"markup",TRUE,NULL);
                   dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));
		  }break;
	   case PROP_TEXTUS:
                   {
                    tex_tus=(char*)g_value_get_string(propiedad);
                    textusImago->tex_tus=tex_tus;
	            g_object_set(textusImago->textus,"font",textusImago->typus,
                                "text",textusImago->tex_tus,
                                "editable",TRUE,NULL);  
                   dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));
                  }break;
	   case PROP_IMAGO:  /*La imagencentral en un pixbuf*/
		 {		
                  textusImago->imagos=(GdkPixbuf*)g_value_get_pointer(propiedad); 
                  /*La imagen es una dia-canvas, sin textusImago padre*/
		   g_object_set(textusImago->centrum,"image",textusImago->imagos,NULL);	 
		  }break;	 
	  default:/*por si se pasa un parámetro que no es*/
			G_OBJECT_WARN_INVALID_PROPERTY_ID(objeto,id_propiedad,propiedad);
			break;
		}//fin del switch
	}


/*entrega las propiedades del elemento, el tipo de propiedad valor*/
static void entrega_propiedades_textus_imago(GObject* objeto,guint id_propiedad,GValue* parametros,GParamSpec* especificacion)
{
  DiaTextusImago* textusImago; /*El representante de este*/
  textusImago=(DiaTextusImago*)objeto;		/*Cambio de tipo*/
  switch(id_propiedad)
  {
    case PROP_TYPUS:  /*La tipografía de la letra*/
		 {
                  g_value_set_boxed(parametros,textusImago->typus); 
		 }break;	
    case PROP_TAMAGNUS_TYPUS:  /*tamaño de la fuente*/
		 {
		 }break;	
    case PROP_NOMENIS:  /*el nombre del cuadro*/
		  {
                   g_value_set_string(parametros,textusImago->nomenis);  
		  }break;
    case PROP_TEXTUS:
                  {
                   g_value_set_string(parametros,textusImago->tex_tus);
                   }break;
    case PROP_IMAGO:
                   {
                     g_value_set_pointer(parametros,textusImago->imagos);
                   }break; 
	      default:
              G_OBJECT_WARN_INVALID_PROPERTY_ID(objeto,id_propiedad,especificacion);	  
        }
	
}	
	

static void dia_textus_imago_groupable_add (DiaCanvasGroupable *textbox, DiaCanvasItem *item)
{
	g_return_if_fail (DIA_IS_TEXTUS_IMAGO (textbox));

}

static void dia_textus_imago_groupable_remove (DiaCanvasGroupable *textbox, DiaCanvasItem *item)
{
	g_return_if_fail (DIA_IS_TEXTUS_IMAGO (textbox));
	//return FALSE;
}

/*
 *La cantidad de elementos es puesto un arreglo de elementos
 */
static gboolean dia_textus_imago_groupable_get_iter (DiaCanvasGroupable *textbox, DiaCanvasIter *iter)
{
	/* -- Si es nulo,retorna --*/
	g_return_val_if_fail (DIA_IS_TEXTUS_IMAGO (textbox),  FALSE);

	iter->data[0] = DIA_TEXTUS_IMAGO (textbox)->textus; /*El texto ppal*/
	iter->data[1] = DIA_TEXTUS_IMAGO (textbox)->textus_bassus;
	iter->data[2] = DIA_TEXTUS_IMAGO (textbox)->centrum;
	return TRUE;
}


/*Al parecer acá hay que entregar los elementos
* PERO LOS PIDE UNO POR UNO
*  EL PRIMERO QUE SE CREA ES EL QUE ESTÁ POR DEFECTO
* LOS DEMÁS SE VAN INCRUSTANDO A MEDIDA QUE SE VAYA LLAMANDO
* EL ÚLTIMO VALOR VA SER SIEMPRE NULL, CON FALSE
*/
static gboolean dia_textus_imago_groupable_next (DiaCanvasGroupable *textbox, DiaCanvasIter *iter)
{
	DiaTextusImago *cajaTexto;
	cajaTexto  = (DiaTextusImago*)textbox;
//	printf("imago 6\n");	
	g_return_val_if_fail (DIA_IS_TEXTUS_IMAGO(textbox),  FALSE);
//	printf("imago A6\n");	
   	if (iter->data[0] == cajaTexto->textus)
	   {
	    iter->data[0] = cajaTexto->textus_bassus;
	    return TRUE;	/*como se cambió el valor es verdadero*/
	   }	
	else if(iter->data[0] == cajaTexto->textus_bassus) /*Si es la caja de texto*/
	   {
	    iter->data[0] = cajaTexto->centrum;
	    return TRUE;	/*como se cambió el valor es verdadero*/
	    } else
	  iter->data[0] = NULL;
		return FALSE;  /*COMO YA NO HAY MÁS EL VALOR ES FALSO*/
   }


   
   
   
   /*Es la que entrega c/u de los items pertenecientes al objeto
 * Siempre apuntando al cero 
 */
static DiaCanvasItem* dia_textus_imago_groupable_value (DiaCanvasGroupable *textbox, DiaCanvasIter *iter)
{
	DiaTextusImago *cajaTexto;
	int num;
	cajaTexto  = (DiaTextusImago*)textbox;
	g_return_val_if_fail (DIA_IS_TEXTUS_IMAGO (cajaTexto),  NULL);
	return iter->data[0];
}
/*La que entrega la cantidad de elementos o de componenets que posee*/
static gint dia_textus_imago_groupable_length (DiaCanvasGroupable *textusImago)
{
	int conta=0;
	g_return_val_if_fail (DIA_IS_TEXTUS_IMAGO (textusImago),  -1);
    if(DIA_TEXTUS_IMAGO (textusImago)->textus)
	   conta++;
    if( DIA_TEXTUS_IMAGO(textusImago)->textus_bassus)
		conta++;
    if( DIA_TEXTUS_IMAGO(textusImago)->centrum)
		conta++;
     return conta;
}

/*Entrega la posición del elemento que está en la caja*/
static gint dia_textus_imago_groupable_pos (DiaCanvasGroupable *textbox, DiaCanvasItem *item)
{
//	printf("imago 9\n");	
	g_return_val_if_fail (DIA_IS_TEXTUS_IMAGO (textbox),  -1);
        if(item == DIA_TEXTUS_IMAGO (textbox)->textus)
		 return 0;
	else if (item == DIA_TEXTUS_IMAGO (textbox)->textus_bassus)
		  return 1;
	else if(item == DIA_TEXTUS_IMAGO (textbox)->centrum)
		 return 2;
	return -1;
}

static gboolean dia_textus_imago_shape_next (DiaCanvasItem *item, DiaCanvasIter *iter)
{
	iter->data[0] = NULL;
	return FALSE;
}

static DiaShape*  dia_textus_imago_shape_value (DiaCanvasItem *item, DiaCanvasIter *iter)
{
	return NULL;// iter->data[0];
}

static gboolean dia_textus_imago_get_shape_iter (DiaCanvasItem *item, DiaCanvasIter *iter)
{
	//iter->data[0] = DIA_TEXTUS_IMAGO(item)->perimetros;
	return FALSE;
}


